/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.records;


import com.alkemy.sophia.api.sophiamsinvoice.dbmodel.jooq.tables.MmBackclaimStatistics;

import java.math.BigDecimal;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record5;
import org.jooq.Row5;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MmBackclaimStatisticsRecord extends UpdatableRecordImpl<MmBackclaimStatisticsRecord> implements Record5<Long, String, BigDecimal, BigDecimal, BigDecimal> {

    private static final long serialVersionUID = 1569249921;

    /**
     * Setter for <code>MM_BACKCLAIM_STATISTICS.ID</code>.
     */
    public void setId(Long value) {
        set(0, value);
    }

    /**
     * Getter for <code>MM_BACKCLAIM_STATISTICS.ID</code>.
     */
    public Long getId() {
        return (Long) get(0);
    }

    /**
     * Setter for <code>MM_BACKCLAIM_STATISTICS.ID_DSR</code>.
     */
    public void setIdDsr(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>MM_BACKCLAIM_STATISTICS.ID_DSR</code>.
     */
    public String getIdDsr() {
        return (String) get(1);
    }

    /**
     * Setter for <code>MM_BACKCLAIM_STATISTICS.TOTALE_VALORE</code>.
     */
    public void setTotaleValore(BigDecimal value) {
        set(2, value);
    }

    /**
     * Getter for <code>MM_BACKCLAIM_STATISTICS.TOTALE_VALORE</code>.
     */
    public BigDecimal getTotaleValore() {
        return (BigDecimal) get(2);
    }

    /**
     * Setter for <code>MM_BACKCLAIM_STATISTICS.TOTALE_UTILIZZAZIONI</code>.
     */
    public void setTotaleUtilizzazioni(BigDecimal value) {
        set(3, value);
    }

    /**
     * Getter for <code>MM_BACKCLAIM_STATISTICS.TOTALE_UTILIZZAZIONI</code>.
     */
    public BigDecimal getTotaleUtilizzazioni() {
        return (BigDecimal) get(3);
    }

    /**
     * Setter for <code>MM_BACKCLAIM_STATISTICS.TOTALE_SUBSCRIPTION</code>.
     */
    public void setTotaleSubscription(BigDecimal value) {
        set(4, value);
    }

    /**
     * Getter for <code>MM_BACKCLAIM_STATISTICS.TOTALE_SUBSCRIPTION</code>.
     */
    public BigDecimal getTotaleSubscription() {
        return (BigDecimal) get(4);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Long> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record5 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row5<Long, String, BigDecimal, BigDecimal, BigDecimal> fieldsRow() {
        return (Row5) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row5<Long, String, BigDecimal, BigDecimal, BigDecimal> valuesRow() {
        return (Row5) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Long> field1() {
        return MmBackclaimStatistics.MM_BACKCLAIM_STATISTICS.ID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return MmBackclaimStatistics.MM_BACKCLAIM_STATISTICS.ID_DSR;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field3() {
        return MmBackclaimStatistics.MM_BACKCLAIM_STATISTICS.TOTALE_VALORE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field4() {
        return MmBackclaimStatistics.MM_BACKCLAIM_STATISTICS.TOTALE_UTILIZZAZIONI;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field5() {
        return MmBackclaimStatistics.MM_BACKCLAIM_STATISTICS.TOTALE_SUBSCRIPTION;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Long component1() {
        return getId();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getIdDsr();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component3() {
        return getTotaleValore();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component4() {
        return getTotaleUtilizzazioni();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component5() {
        return getTotaleSubscription();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Long value1() {
        return getId();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getIdDsr();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value3() {
        return getTotaleValore();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value4() {
        return getTotaleUtilizzazioni();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value5() {
        return getTotaleSubscription();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmBackclaimStatisticsRecord value1(Long value) {
        setId(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmBackclaimStatisticsRecord value2(String value) {
        setIdDsr(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmBackclaimStatisticsRecord value3(BigDecimal value) {
        setTotaleValore(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmBackclaimStatisticsRecord value4(BigDecimal value) {
        setTotaleUtilizzazioni(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmBackclaimStatisticsRecord value5(BigDecimal value) {
        setTotaleSubscription(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public MmBackclaimStatisticsRecord values(Long value1, String value2, BigDecimal value3, BigDecimal value4, BigDecimal value5) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached MmBackclaimStatisticsRecord
     */
    public MmBackclaimStatisticsRecord() {
        super(MmBackclaimStatistics.MM_BACKCLAIM_STATISTICS);
    }

    /**
     * Create a detached, initialised MmBackclaimStatisticsRecord
     */
    public MmBackclaimStatisticsRecord(Long id, String idDsr, BigDecimal totaleValore, BigDecimal totaleUtilizzazioni, BigDecimal totaleSubscription) {
        super(MmBackclaimStatistics.MM_BACKCLAIM_STATISTICS);

        set(0, id);
        set(1, idDsr);
        set(2, totaleValore);
        set(3, totaleUtilizzazioni);
        set(4, totaleSubscription);
    }
}
